<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api'
import { CodeRecord, NonePayload, Workstation, DDR } from "@/model"

export default defineComponent({
	name: "Station",
	props: {
		station: {
			type: Object as () => Workstation,
			required: true
		} 
	},
	setup(props, context) {
		function hasPayload(record: CodeRecord) {
			return record.payloadType !== NonePayload;
		}
		return {
			hasPayload,
			DDR
		}
	},
})
</script>

<template>
	<v-card>
		<div class="name overline">
			{{station.label}}
		</div>

		<v-btn outlined color="gray" v-for="record in station.codetable" :key="record.label" @click="$emit('send', {record})">
			<v-icon v-if="hasPayload(record)" class="has-payload" small>mdi-dots-horizontal</v-icon>
			<v-icon>{{record.direction == DDR.FROM_SERVER ? "mdi-server" : "mdi-remote-desktop"}}</v-icon>
			{{record.code}} - {{record.label}}
		</v-btn>
	</v-card>
</template>

<style scoped>
.v-card {
	padding: 0.5em;
	margin: 0.5em;
	display: flex;
	gap: 0.5em;
	align-items: center;
	min-width: max-content;
}
.name{
	min-width: 10em;
	text-align: center;
}
.v-btn{
	position: relative;
	min-height: 9.8em;
	width: 12em;
	flex-wrap: wrap;
}
.v-btn >>> .v-btn__content{
	position: static; /* Because of v-btn relative */
	flex-direction: column;
	flex-wrap: wrap;
	width: 100%;
	white-space: normal;
}

.v-icon {
	padding-bottom: 10px;
}
.has-payload {
	position: absolute;
	top: 5px;
	right: 10px;
}
</style>